// iceWMcnfg v0.0.1 dev.
// justin pessa <just1n@sdf.lonestar.org>


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pwd.h>

#define ver "0.0.1 dev"

void clr(void); // clears screen
void menu(void); // pritns user menu
void heading(void); // prints program heading
void append(char *, char *, char *); // add item to toolbar file
void toolbar(void); // add/remove from toolbar

main(){
  
  int choice;

  clr();
  
  while( choice != 8 ){
    
    heading();
    menu();

    scanf("%d", &choice);
 
    switch(choice){

    case 1:
      toolbar();
      break;
    
    case 5: 
      system("killall -HUP icewm");
      break;     
    case 8:
      clr(); heading();
      printf("\nGoodbye.\n\n");
      return 0;
     
    default:
      menu();
      break;
   
    }

    clr();
    choice = 0;

  }

} 
 
                  /****************************
		  *    FUNCTION PROTOTYPES    *
                  ****************************/

// Clear Screen

void clr(void){
  char a[80];
  printf("\033[2J");       // Clear the entire screen.
  printf("\033[0;0f");     // Move cursor to the top left hand corner
}

// Printf Heading

void heading (void){

printf("iceWMcnfg %s release coded by\n"
       "justin pessa <just1n@sdf.lonestar.org>\n", ver);

}

// Printf Menu

void menu(void){

  printf("\nPlease select a field to edit:\n\n"
	 "   1. Toolbar  5. Restart icewm\n"
	 "   2. Menu     6. Help\n"
	 "   3. Theme    7. About\n"
	 "   4. Desktop  8. Quit\n\n> ");
         
}

// Edit Toolbar

void toolbar(void){
  
  int choice1, count;
  char write;
  char hover[20] = { };
  char icon[20] = { };
  char prog[40] = { };

while( choice1 != 3 ){

  clr();
  heading();

  // reset arrays to 0
  for(count = 0; hover[count] != '\0'; ++count)
    hover[count] = 0;
  for(count = 0; icon[count] != '\0'; ++count)
    icon[count] = 0;
  for(count = 0; prog[count] != '\0'; ++count)
    prog[count] = 0;

  choice1 = 0;
  
  if(write =='y')
    printf("\nTool bar updated.\n"); 
  if(write == 'n')
    printf("\nSettings abandoned.\n"); write = '\0';

  printf("\nSelect an option:\n\n"
	 "   1. Add an item.\n"
	 "   2. Remove an item\n"
	 "   3. Back\n\n> ");
  scanf("%d", &choice1);
  
  // Prompt for user input Hover text, 
  // icon name, program name

  switch(choice1){
    case 1:
      clr(); heading();
      printf("\nHover text:\n> ");
      scanf("%s", &hover);
      clr(); heading();
      printf("\nIcon name:\n> ");
      scanf("%s", &icon);
      clr(); heading();
      printf("\nLocation of executable:\n> ");
      scanf("%s", &prog);
      clr(); heading(); getchar();
      printf("\nWrite 'prog %s %s %s'\n"
             "to ice toolbar config file? (y/n): ", hover, icon, prog); 
      scanf("%c", &write);
      if( write == 'y'){
	append( hover, icon, prog); 
      break;
      }
      else{
	write = 'n';
	break;
      }
      case 2:
      break;
    case 3:
      choice1 = 3;
      break;
    default: 
      break;
      
  }
      
}


}

// Add items to end of ~/.icewm/toolbar

void append(char *hovertxt, char *icontxt, char *progtxt){

  FILE *ptr;
  char path[40] = { };
  int count = 0;

  const char *file = { "/.icewm/toolbar" }; // default path to toolbar file

  struct passwd *name;
  name = getpwuid( getuid() );

  sprintf( path, "%s%s", (char *)name->pw_dir, (char *)file);  // create ~/.icewm/toolbar path
 
  if( !(ptr = fopen( path , "a+" ) ) ) 
    printf("\nFile not found\n");  
  else{
    fprintf( ptr ,"prog %s %s %s\n", hovertxt, icontxt, progtxt);
    fclose(ptr);
  }
}

